unit uMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls
  ,fpreport
  ,dbf
  ,fpreportdb
  ,fpttf
  ,fpreportpdfexport
  ,fpReportStreamer
  ,fpjson
  ;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private

  public
    procedure LoadReportDesign(aReport :TFPCustomReport; aFileFprPath: string);
  end;

var
  Form1: TForm1;

implementation

{$R *.frm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  rpt: TFPCustomReport;
  lDataSet: TDBF;
  lReportData: TFPReportDatasetData;
  RptExporter: TFPReportExporter;

begin
  RptExporter := nil;
  if not FileExists('data\test.dbf') then
  begin
    writeln('Unable to find database file <test.dbf>!');
    writeln('');
    exit;
  end;

  // ***** Providing data to the report *****
  lReportData := TFPReportDatasetData.Create(nil);
  lDataSet := TDBF.Create(nil);
  lDataSet.TableName := 'data\test.dbf';
  lReportData.DataSet := lDataSet;

  rpt := TFPCustomReport.Create(self);

  self.LoadReportDesign(rpt, 'data\test.json');


  TFPReportDataBand(rpt.FindRecursive('DataHeaderBand1')).Data := lReportData;
  TFPReportDataBand(rpt.FindRecursive('DataBand1')).Data := lReportData;

  try
    // ***** Running the report *****
    gTTFontCache.SearchPath.Add('fonts\');
    gTTFontCache.BuildFontCache;
    rpt.RunReport;

    // ***** Rendering (or exporting) the report *****
    if Assigned(RptExporter) then
      FreeAndNil(RptExporter);
    RptExporter := TFPReportExportPDF.Create(nil);
    rpt.RenderReport(RptExporter);

    ShowMessage('File created.');

  finally
    // Freeing all objects we used
    FreeAndNil(RptExporter);
    FreeAndNil(rpt);
    FreeAndNil(lReportData);
    FreeAndNil(lDataset);
  end;
end;

procedure TForm1.LoadReportDesign(aReport: TFPCustomReport; aFileFprPath: string);
Var
  J : TFPReportJSONStreamer;
  F : TFileStream;
  O : TJSONObject;

begin
  J:=Nil;
  F:=TFileStream.Create(aFileFprPath,fmOpenRead);
  try
    O:=GetJSON(F) as TJSONObject;
    J:=TFPReportJSONStreamer.Create(Self);
    J.JSON:=O;
    J.OwnsJSON:=True;
    aReport.ReadElement(j);
  finally
    F.Free;
    J.Free;
  end;
end;

end.

